> For the complete documentation index, see [llms.txt](https://docs.tuum.tech/hedera-wallet-snap/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tuum.tech/hedera-wallet-snap/hedera-wallet-snap/snap-rpc-apis/account-apis/deleteallowance.md).

# deleteAllowance

## How to call the API from an app

Hedera Wallet Snap connects to your currently connected Metamask account by default. To learn how apps can connect to Hedera Wallet Snap using a non-metamask(external) account, refer to this [documentation](/hedera-wallet-snap/hedera-wallet-snap/snap-rpc-apis.md#connecting-to-a-non-metamask-external-account).&#x20;

Then, depending on whether you're trying to connect to a metamask account or a non-metamask account, you can call the snap API in the following way:

```tsx
const snapId = `npm:@hashgraph/hedera-wallet-snap`

const deleteAllowanceAPI = async () => {
  const externalAccountParams = {
    externalAccount: {
      accountIdOrEvmAddress: '0.0.12345',
      curve: 'ED25519'
    }
  }

  await window.ethereum.request({
    method: 'wallet_invokeSnap',
    params: {
      snapId,
      request: {
        method: 'deleteAllowance',
        params: {
          network: 'testnet',
          assetType: 'HBAR', // 'HBAR' | 'TOKEN' | 'NFT'
          spenderAccountId: '0.0.67890', 
          /* 
            Uncomment the below line if you want to connect 
            to a non-metamask account
          */
          // ...externalAccountParams
        }
      }
    }
  })
}
```

{% hint style="info" %}
For assetType HBAR/TOKEN, you must pass the parameter `spenderAccountId.`

For asetType TOKEN/NFT, you must pass the parameter `assetId` that is either the token id or nft id.
{% endhint %}

Note that you can also call this API to delete allowance for other tokens and nfts.&#x20;

For tokens, you would need to pass in additional parameters as shown below:

```tsx
const snapId = `npm:@hashgraph/hedera-wallet-snap`

  await window.ethereum.request({
    method: 'wallet_invokeSnap',
    params: {
      snapId,
      request: {
        method: 'deleteAllowance',
        params: {
          network: 'testnet',
          assetType: 'TOKEN',
          spenderAccountId: '0.0.67890'
          assetId: '0.0.45634' // This is token ID
        }
      }
    }
  })
}
```

For nfts, you would need to pass in additional parameters as shown below:

```tsx
const snapId = `npm:@hashgraph/hedera-wallet-snap`

  await window.ethereum.request({
    method: 'wallet_invokeSnap',
    params: {
      snapId,
      request: {
        method: 'approveAllowance',
        params: {
          network: 'testnet',
          assetType: 'NFT',
          assetId: '0.0.57894' // This is nft ID
        }
      }
    }
  })
}
```

## What the API does

1. Retrieves the currently connected account the user has selected on Metamask. If it's the first time, a new [snap account](/hedera-wallet-snap/hedera-wallet-snap/snap-account.md) is created and the account info is saved in snap state.
2. Calls the [Hedera SDK Delete Allowance API](https://docs.hedera.com/hedera/sdks-and-apis/sdks/accounts-and-hbar/adjust-an-allowance) that allows a token owner to delete allowances. For NFTs, `deleteAllTokenNftAllowances` is called to delete the allowances for the given NFT ID. For hbar and fungible tokens, `approveTokenAllowance` is called with the amount of 0 to delete the allowances.
3. Returns the transaction receipt as response.

Some example responses:

For a hedera account id `0.0.4559`:

```json
{
  "currentAccount": {
    "hederaAccountId": "0.0.4559",
    "hederaEvmAddress": "0x3ba201df50314e4702d4d92b52d304ee63bfca23",
    "balance": {
      "hbars": 89.60420503,
      "timestamp": "2024-02-01T21:35:21.826Z",
      "tokens": {}
    },
    "network": "testnet"
  },
  "receipt": {
    "status": "SUCCESS",
    "accountId": "",
    "fileId": "",
    "contractId": "",
    "topicId": "",
    "tokenId": "",
    "scheduleId": "",
    "exchangeRate": {
      "hbars": 1,
      "cents": 12,
      "expirationTime": "Mon, 25 Nov 1963 17:31:44 GMT",
      "exchangeRateInCents": 12
    },
    "topicSequenceNumber": "0",
    "topicRunningHash": "",
    "totalSupply": "0",
    "scheduledTransactionId": "",
    "serials": [],
    "duplicates": [],
    "children": []
  }
}
```

## Live Demo on CodePen

{% embed url="<https://codepen.io/kpachhai/pen/mdoLyvo>" %}

{% hint style="info" %}

* **Note**: Visit <https://pulse.tuum.tech/> to activate your hedera account before you interact with the demo
* If you're getting any errors with the live demo, make sure you go through the [FAQs](/hedera-wallet-snap/basics/faqs.md) section to learn about what you may be missing. You need to install [Metamask](https://metamask.io/) in your browser for the live demo to work.&#x20;
* To ease the integration of Hedera Wallet Snap on an application, we have created a template web application that you can run locally and check out the code in its entirety to learn how you can integrate and interact with various APIs exposed by Hedera Wallet Snap. Check out the full source code at [template application github repository](https://github.com/hashgraph/hedera-metamask-snaps/tree/main/packages/hedera-wallet-snap/packages/site).
* You can also check out the [API reference](/hedera-wallet-snap/hedera-wallet-snap/snap-rpc-apis.md) to learn how each API works.
  {% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tuum.tech/hedera-wallet-snap/hedera-wallet-snap/snap-rpc-apis/account-apis/deleteallowance.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
